*****************************************************************************
* Modulname:	_ApLet_
* Modultype:	ApLet
* Dest.Comp.:	HP38G
* Language:	System RPL
* Author:	Detlef Mueller, Bellerbek 33, 22559 Hamburg, Germany
* Interface:
* Description:	Empty but full featured "embedded code ApLet" (CAPLET)
*		frame. Replace all _ApLet_ references by the name of
*		your ApLet. Check for comments marked w/ "*>>>"
* To do:
*
* Copyright:	(c) 1999 by Detlef Mueller. ALL rights reserved.
*
* $Id: aplet.s 1.4.1.1 1999/05/11 21:56:36 Detlef Rel $
*
* $Log: aplet.s $
* Revision 1.4.1.1  1999/05/11 21:56:36  Detlef
* Slightly refined documentation.
*
* Revision 1.4  1999/05/02 02:39:45  Detlef
* Reworked mayor parts of the inline documentation. Renamed nXTT to
* view01_CApLet (to match the name conventions). Added some more view*
* EXTERNALs. Changed the NullMenuKey to what it actually is intended,
* an EXTERNAL. Renamed Action to Run. Added INT_NN EQU. Added an
* ApLet Reset entry to the VIEWS menu. Removed BINT expansion when
* leaving the ApLet, not necessary. Moved the display handler, the
* key handler and the menu definition into seperate routines. Added
* up/down key handling using the 2nd formerly redundant parameter.
*
* Revision 1.3  1999/02/28 16:01:52  Detlef
* Changed to refer to lib #602, providing a fix for the XTTheta key
* problem. Replaced StndtType by an own tType w/ the following changes:
* view01_CAPLET is replaced by nXTT (from our lib), xREADPICT is replaced
* by view7_CAPLET to disable the sketch view. Also StndCheck by an own
* list w/ an extended VIEW list -- "Start" now reads "Enter ...", added
* "Read note" to immediately jump to the Notes view.
*
* Revision 1.2  1999/01/11 19:51:58  Detlef
* Added a few comments
*
* Revision 1.1  1999/01/10 19:50:19  Detlef
* Initial revision
*
*****************************************************************************

    TITLE	_ApLet_


*****************************************************************************
*		INCLUDE FILES
*****************************************************************************

    INCLUDE	common38.h


*****************************************************************************
*		APLET LAYOUT
*****************************************************************************

ASSEMBLE
	Dir_Head 7,_ApLet_,602
*>>>		 ^
*		 +-- Length of the following name (in chars)

~view01_CApLet	EQU	(#602)+4096*0
RPL

EXTERNAL	view01_CApLet		( tType for taking over Plot View   )

EXTERNAL	view6_CAPLET		( tType for taking over Note View   )
EXTERNAL	view7_CAPLET		( tType for taking over Sketch View )

EXTERNAL	NullMenuKey		( On the '38G, the NMK is a ROMPTR  )


	{				( tType variable, 1st var in dir    )
	    topic_CAPLET		( Topic type -- embedded code aplet )
	    view01_CApLet		( Plot type  -- points to our lib   )
	    view23_CAPLET		( Table type )
	    view45_CAPLET		( Symb type )
	    xREADNOTE			( Note type, use xDFLTNOTE for R/W, )
					( view6_CAPLET to take over the view)
	    view7_CAPLET		( Pict type, here taken over.Altern:)
					( xREADPICT [RO], xDFLTPICT [R/W]   )
	}


    INCLUDE	share38.h		( Minimal variable set neccessary   )
					( for every ApLet                   )

ASSEMBLE
	Vfield  L34,IntTable

	CON(5)	=DOHSTR			Linktable variable, provides links
	REL(5)  endLink			to the objects w/in the next variable

	Link	_Main
	Link	_MainDisp
	Link	_MainKeys
	Link	_MainMenu

	Link	_Run

*>>>	Add links to more routines here, they must
*	be paired w/ the defines just below

endLink
RPL

DEFINE	Main		INT_00
DEFINE	MainDisp	INT_01
DEFINE	MainKeys	INT_02
DEFINE	MainMenu	INT_03

DEFINE	Run		INT_04

*>>>	Add defines for more routines here
*	INT_05..INT_09, INT_0A..INT_0F or BINT INT_NN
*	Use INT_10..INT_1F and INT_NN w/ care !


ASSEMBLE
	Vfield  IntTable,DirVar

	CON(5)	=DOHSTR			Code variable, containes the sRPL
	REL(5)  codeEnd			objects encapsulated in a HSTR
RPL


*****************************************************************************
*		DEFINES
*****************************************************************************

ASSEMBLE
***		Some unsupported but usefull entries

=#4-		EQU	#DF143

=INT_10 	EQU	#7D7ED	Use only as last resort, these are
=INT_11 	EQU	#7D7FA	direct entries, not jumptabled ones...
=INT_12 	EQU	#7D807
=INT_13		EQU	#7D814
=INT_14		EQU	#7D821
=INT_15		EQU	#7D82E
=INT_16		EQU	#7D83B
=INT_17		EQU	#7D848
=INT_18		EQU	#7D855
=INT_19		EQU	#7D862
=INT_1A		EQU	#7D86F
=INT_1B		EQU	#7D87C
=INT_1C		EQU	#7D889
=INT_1D		EQU	#7D896
=INT_1E		EQU	#7D8A3
=INT_1F		EQU	#7D8B0
=INT_NN		EQU	#7D6BD	( # --> ) to call routine no. #

=NotesViewUI	EQU	#31885

=SetSomeRow	EQU	#3F0C7
=GETKEY*	EQU	#3E79F
=CtlAlarm!	EQU	#3EC8F
=DoCAlarmKey	EQU	#3EC76
=H/W>KeyCode	EQU	#3C7B0

=Disp5x7	EQU	#8882B	Fundamental...

=SavPtrTime*	EQU	#01331
=Push#TLoop	EQU	#036F7
=Push2#Loop	EQU	#03F64

=$jGPPushT/FL	EQU	#81133	This one is save.
RPL


DEFINE	FOURTY		FORTY		( Well... )

DEFINE	SF_IO_IR	THIRTYTHREE	( I/O device system flag )
DEFINE	SF_SoundOff	FIFTYSIX	( Sound off flag )

DEFINE	kpShift		TWO
DEFINE	kpAShft		FIVE
DEFINE	kcShift		THIRTYFIVE


*>>>	The following few defines deal w/ the variable
*	storage. For each variable to add, 1. extend
*	the list found near the end of this file and
*	2. add the @/! defines. A 3rd value will be
*	mapped to TopicVar3, a 4th to TopicVar4 and
*	so on. You may choose more meaningfull names.

DEFINE	@Par		LastBut3
DEFINE	!Par		LastBut3 REPLACE DROP

DEFINE	Par1@		TopicVar1@
DEFINE	Par1!		TopicVar1!
DEFINE	Par2@		TopicVar2@
DEFINE	Par2!		TopicVar2!


*****************************************************************************
*		OBJECTS
*****************************************************************************


*** _Main *******************************************************************
* Interface :	( --> )
* Description :	Main program
*****************************************************************************

NAMELESS	_Main
::
    {   MINUSONE
	{				( This is the VIEWS menu	  )
	    {	"Enter _ApLet_"
		:: ZERO INT_00		( Enter via plot view		  )
		;
	    }
	    {	"View note"
		NotesViewUI
	    }
	    {	"Reset"			( Reset entry, remove it if you	  )
		:: EIGHT INT_00		( won't provide an ApLet reset	  )
		;
	    }
	}
	StndVar
**	StndReset			( -3 never passed unless	  )
					( _Aplet_ == 'MiscAplet		  )
	StndEntry
	StndExit
    }
    BinLookup case EVAL

    EIGHT #= IT				( # may be:	ApLet entered by:  )
    ::	{ TRUE FOUR } TOTEMPOB		( ZERO	plot view 		   )
	!Par				( ONE	plot setup view 	   )
    ;					( TWO	numeric view		   )
					( THREE	num. setup view		   )
					( FOUR	symbolic view		   )
					( FIVE	symb. setup view	   )
					( SIX	note view, if using tType  )
					(	entry view6_CAPLET	   )
					( SEVEN	sketch view,if using tType )
					(	entry view7_CAPLET	   )
					( EIGHT	do reset, if enabled	   )

    ( Note for all following quoted objects: as	)
    ( they grow further, it suggested to move	)
    ( them to become [named] INT_xx objects.	)

    '					( **View entry** )
    ::					( *Load parameter into TopicVars* )
	@Par INNERDUP			( --> ... #n #n )

	ZERO_DO (DO)
	    SWAP OVER			( --> ... #n ob #n )
	    INDEX@#- TopicVarN!
	LOOP

	DROP

	SF_SoundOff			( Set Beep on/off according to Par1 )
	Par1@ ITE			( SF_Sound set means beep off... )
	    ClrSysFlag
	    SetSysFlag
    ;

    ' 					( **View exit** )
    ::					( *Save TopicVars into parameter* )
	@Par LENCOMP DUP 		( --> #n )

	#1+_ONE_DO (DO)
	    INDEX@ TopicVarN@ SWAP	( --> ... ob #n )
	LOOP

	%0AllTopicVs			( Clear all topic vars )

	{}N !Par			( Store parameter into ApLet )

	SF_SoundOff SetSysFlag		( Beep off is default )

	SetDAsBad			( Signal bad display )
	DropJunk			( Drop any leftovers )
    ;

    ' MainDisp				( **View display** )

    ' MainKeys 				( **View hard key handler** )

    TRUE				( **Allow normal keys** )

    MainMenu				( **Initial menu** )
				( Note: if the menu grows and/or you're	)
				( using ParOuterLoop's, change MainMenu	)
				( to ' :: MainMenu ; to save memory	)

    ONE 				( **Initial menu page** )

    '					( **Error object** )
    ::	TURNMENUON RECLAIMDISP		( Enshure AGROB to be displayed )
	ERRJMP
    ;
;

*** _MainDisp ***************************************************************
* Interface :	( --> )
* Description :	Main view display handler
*****************************************************************************

NAMELESS	_MainDisp
::
    DA3OK?NOTIT ?DispMenu		( Redraw menu if not ok )

    DA1OK? KEYINBUFFER? OR ?SEMI	( Leave if DA1 is ok or key in buffer )

    RECLAIMDISP				( Clr rows 0-55 )

*>>>	Redraw main display here

    "_ApLet_ display\1F"
    Par2@ DISPN				( Very simple sample... :*)

    SetDA1Valid				( Signal main display valid )
;

*** _MainKeys ***************************************************************
* Interface :	( --> )
* Description :	Main view hardkeys handler
*****************************************************************************

NAMELESS	_MainKeys
::					( `Main' keybinding )
    kpNoShift #=casedrop		( Check/process unshifted keys )
    ::
	DUP#<7 casedrpfls		( Enable menukeys )

	kcEnter ?CaseKeyDef		( Enter: call Run )
	::	TakeOver
	    Run
	;

	kcNegate ?CaseKeyDef		( -X: Toggle sound on/off )
	::  TakeOver

	    Par1@ NOT Par1!

	    SF_SoundOff
	    Par1@ ITE
		ClrSysFlag
		SetSysFlag

	    SetDA3Bad			( Signal to redraw menu )
	;

	kcUpArrow ?CaseKeyDef		( Up: move main-text one line up )
	::	TakeOver

	    Par2@
	    ONE #=casedrop DoBadKey

	    #1- Par2!
	    SetDA1Bad			( Signal to redraw main display )
	;

	kcDownArrow ?CaseKeyDef		( Down: move main-text one line down )
	::	TakeOver

	    Par2@
	    SEVEN #=casedrop DoBadKey

	    #1+ Par2!
	    SetDA1Bad			( Signal to redraw main display )
	;

*>>>	Add other key handling here

	kcShift #=casedrpfls		( Allow shift )

	kcPlotView ?CaseKeyDef DoBadKey ( Disallow Plot/Symb/Num views )
	kcSymbView ?CaseKeyDef DoBadKey
	kcNumView  ?CaseKeyDef DoBadKey
	kcVarsMenu ?CaseKeyDef DoBadKey ( Disallow Vars/Math menus, )
	kcMathMenu ?CaseKeyDef DoBadKey ( they map in the menu bar  )

	DUP kpNoShift IsTaskSwKey? casedrpfls

	DROP 'DoBadKeyT			( Illegal key )
    ;

    kpShift #=casedrop			( Check/process shifted keys )
    ::
	kcShift #=casedrpfls		( Allow shift )

	kcOn #=casedrpfls		( Allow power off )

*>>>	Add other shifted key handling here

	kcPlotView ?CaseKeyDef DoBadKey ( Disallow Plot/Symb/Num views )
	kcSymbView ?CaseKeyDef DoBadKey
	kcNumView  ?CaseKeyDef DoBadKey
	kcMathMenu ?CaseKeyDef DoBadKey ( Disallow Sketch view )
	kcLibrary  ?CaseKeyDef DoBadKey ( Disallow Views [maps in menu] )

	DUP kpLeftShift IsTaskSwKey? casedrpfls

	DROP 'DoBadKeyT			( Illegal key )
    ;

*>>>	Add alpha key handling here

    2DUP IsTaskSwKey? case2drpfls	( Task-switch key not handled above ? )

    2DROP 'DoBadKeyT			( Illegal keyplane )
;


*** _MainMenu ***************************************************************
* Interface :	( --> )
* Description :	Main view menu definition
*****************************************************************************

NAMELESS	_MainMenu
{					( **Initial menu** )
    {					( Call Run )
	"RUN"
	::  TakeOver
	    Run
	;
    }
    NullMenuKey				( Just some blank entries )
    NullMenuKey
    NullMenuKey
    NullMenuKey
    {
	::  TakeOver
	    "BEEP" Par1@ Box/StdLabel
	;
	::  TakeOver

	    Par1@ NOT Par1!

	    SF_SoundOff
	    Par1@ ITE
		ClrSysFlag
		SetSysFlag

	    SetDA3Bad			( Signal to redraw menu )
	;
    }
}

*** _Run ********************************************************************
* Interface :	( --> )
* Description :	Play a little melody
*****************************************************************************

NAMELESS	_Run
::
    300 554 OVER 659 SEVENTYFIVE 740 150
    6PICK 4PICK 6PICK 4PICK OVER

    SIX ZERO
    DO
	setbeep
    LOOP

    SetDA1Bad				( Signal to redraw main display )
;

*****************************************************************************
*		End of Objects
*****************************************************************************

ASSEMBLE
codeEnd
RPL


*****************************************************************************
*		PARAMETER
*****************************************************************************

ASSEMBLE
	Vfield DirVar,DirCode
RPL
  {
	TRUE			( Par1 -- Beep on/off flag. Here ON. )
	FOUR			( Par2 -- Line to display the main-text )

*>>>	Add more parameter here

  }


*****************************************************************************
*		AltViews -- the list _must_ be empty for a CAPLET
*****************************************************************************

ASSEMBLE
	Vfield DirCode,DirAlt
RPL
  { }


*****************************************************************************
*		ApLet note -- most time (c) & quick reference
*****************************************************************************

ASSEMBLE
	Vfield DirAlt,DirNot

	CON(5)	=DOCSTR
	REL(5)	noteEnd

	NIBASC	" _ApLet_ for the '38G\n"
	NIBASC	"\n"
	NIBASC	"  '99 Detlef Mller\n"
	NIBASC	"   <detlef@provi.de>\n"
	NIBASC	"\n"
	NIBASC	" $Revision: 1.4.1.1 $"
*		 1234567890123456789012
noteEnd
RPL


*****************************************************************************
*		SketchSet -- here none. May contain stuff (SKETCH is disabled)
*****************************************************************************

ASSEMBLE
	Vfield DirNot,DirEnd
RPL
  { }


******************************************************************************
*			End of _Aplet_.S
******************************************************************************